package com.ann.demo.entity.filing;

import lombok.Data;
import org.hibernate.annotations.GenericGenerator;

import javax.persistence.*;
import java.util.Date;

/**
 * @Description 患者清单详情 是 ArchiveMaster患者清单 从属关系
 * @Date 2019/7/9 10:07
 * @Created by  ljx
 */
@Table(name = "archive_detail_20201218")
@Entity
@Data
public class ArchiveDetail20201218 {

    @Id
    @GenericGenerator(name = "system-uuid", strategy = "uuid2")
    @GeneratedValue(generator = "system-uuid")
    private String id;

    private String pdfPath;

    // -----------------------绑定关系
    @Column(name = "masterid")
    private String masterID;

    @Column(name = "uploaddatetime")
    private Date upLoadDateTime;

    @Column(name = "assortid")
    private String assortID;

    private String source;

    @Column(name = "subassort")
    private String subAssort;

    private String title;

    // 0 使用 1是系统作废 2是老数据作废 3是新数据作废 88历史数据作废
    private String flag = "0";

    private String sys;

    /**
     * 扩展字段： 用于进行更新状态、与报告进行匹配
     * 2019-9-4
     */
    private String applyId;

    @Column(name = "page_number")
    private Integer number;

    public ArchiveDetail20201218() {
    }

    public ArchiveDetail20201218(String masterID, Date upLoadDateTime, String assortID, String source) {
        this.masterID = masterID;
        this.upLoadDateTime = upLoadDateTime;
        this.assortID = assortID;
        this.source = source;
    }

    public ArchiveDetail20201218(String masterID, Date upLoadDateTime, String assortID, String source, String applyId, String pdfPath, Integer number) {
        this.masterID = masterID;
        this.upLoadDateTime = upLoadDateTime;
        this.assortID = assortID;
        this.source = source;
        this.applyId = applyId;
        this.pdfPath = pdfPath;
        this.number = number;
    }
}
