package com.ann.demo.repository;

import com.ann.demo.entity.interfaceEntity.ArchiveMaster;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * @Author: LeiJiaXin
 * @Date: 2019/7/11 20:55
 */
@Repository
public interface ArchiveMasterRepository extends JpaRepository<ArchiveMaster, String> {

    public ArchiveMaster findByInpNoAndVisitIdAndIsValid(String inpNo, String visitId, Integer isValid);

    @Query("select o from ArchiveMaster o where o.archiveState <> '作废' and o.id = ?1")
    public ArchiveMaster findArchiveMaster(String id);

}
